#!/usr/bin/env python2.4
from subprocess import Popen, PIPE
from urllib import urlencode
from xml.sax.saxutils import escape
import os.path

REQ_DIR = '/home/abentley/pastegraph'

class Node(object):
    def __init__(self, name, color=None):
        self.name = name
        self.color = color

    def define(self):
        if self.color is not None:
            return '%s[fillcolor="%s" style="filled"]' % \
                (self.name, self.color)

    def __str__(self):
        return self.name

def dot_output(my_file, relations):
    defined = set()
    yield "digraph G\n"
    yield "{\n"
    for (start, end) in relations:
        if start.name not in defined:
            defined.add(start.name)
            my_def = start.define()
            if my_def is not None:
                yield "    %s;\n" % my_def
        if end.name not in defined:
            defined.add(end.name)
            my_def = end.define()
            if my_def is not None:
                yield "    %s;\n" % my_def

        yield "    %s->%s;\n" % (start.name, end.name)
    yield "}\n"

def invoke_dot(input, out_file=None):
    cmdline = ['dot', '-Tgif']
    if out_file is not None:
        cmdline.extend(('-o', out_file))
    dot_proc = Popen(cmdline, stdin=PIPE)
    for line in input:
        dot_proc.stdin.write(line)
    dot_proc.stdin.close()
    return dot_proc.wait()
